//+-------------------------------------------------------------------+
//|The indicator shows the maximum and minimum for the last N candles |
//|             Copyright  2012,  (Khlystov Vladimir) |
//|                                                                   |
//|                                                 cmillion@narod.ru |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2012, http://cmillion.narod.ru"
#property link      "cmillion@narod.ru"
#property indicator_chart_window
//--------------------------------------------------------------------
extern int N                     = 45; //number of candles
extern ENUM_TIMEFRAMES timeFrame = PERIOD_CURRENT;
extern int YPosition             = 152;
extern int XPosition             = 2;
string ButtonID                  = "Min/MaxButton";
int Nstart                       = N;
bool returnBars;
//--------------------------------------------------------------------
int OnInit()
{
    if (ObjectFind("main"+ButtonID)!=0)
    {
      int ButtonXSize = 190;
      int ButtonYSize = 20;
      ObjectCreate(ChartID(),"main"+ButtonID,OBJ_BUTTON,0,0,0);
         ObjectSetString(ChartID(),"main"+ButtonID,OBJPROP_FONT,"Arial");
         ObjectSetString(ChartID(),"main"+ButtonID,OBJPROP_TEXT,"Min/Max is "+string(N)+" bars");
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_FONTSIZE,10);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_YDISTANCE,YPosition);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_XDISTANCE,XPosition);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_XSIZE,ButtonXSize-40);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_YSIZE,ButtonYSize);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_SELECTABLE,false);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),"main"+ButtonID,OBJPROP_STATE,false);
         
      ObjectCreate(ChartID(),"sub"+ButtonID+"Up",OBJ_BUTTON,0,0,0);
         ObjectSetString(ChartID(),"sub"+ButtonID+"Up",OBJPROP_FONT,"Wingdings");
         ObjectSetString(ChartID(),"sub"+ButtonID+"Up",OBJPROP_TEXT,CharToString(241));
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_FONTSIZE,10);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_YDISTANCE,YPosition);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_XDISTANCE,ButtonXSize-40+2);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_XSIZE,20);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_YSIZE,20);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_SELECTABLE,false);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Up",OBJPROP_STATE,false);
         
       ObjectCreate(ChartID(),"sub"+ButtonID+"Down",OBJ_BUTTON,0,0,0);
         ObjectSetString(ChartID(),"sub"+ButtonID+"Down",OBJPROP_FONT,"Wingdings");
         ObjectSetString(ChartID(),"sub"+ButtonID+"Down",OBJPROP_TEXT,CharToString(242));
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_FONTSIZE,10);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_CORNER,0);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_COLOR,clrWhite);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_BGCOLOR,clrDimGray);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_YDISTANCE,YPosition);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_XDISTANCE,ButtonXSize-20+2);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_XSIZE,20);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_YSIZE,20);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_SELECTABLE,false);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_HIDDEN,true);
         ObjectSetInteger(ChartID(),"sub"+ButtonID+"Down",OBJPROP_STATE,false); 
         
   } 


   timeFrame = MathMax(Period(),timeFrame);
   return(0);
}
void OnDeinit(const int reason)
{
    if (!returnBars)
    switch(reason)
    {
         case REASON_CHARTCHANGE :
         case REASON_RECOMPILE   :
         case REASON_CLOSE       : break;
         default :
         {
           ObjectDelete("Max");
           ObjectDelete("Min");
           ObjectDelete("Max1");
           ObjectDelete("Min1");
   
           for(int i=ObjectsTotal(); i>=0; i--)
               {
                string name=ObjectName(i);
                if(StringFind(name,ButtonID)!=-1) ObjectDelete(name);             
               }
         }
      }      

}
//--------------------------------------------------------------------
void OnChartEvent(const int id, const long& lparam, const double& dparam, const string& sparam)
{
   if (id==CHARTEVENT_OBJECT_CLICK && sparam=="sub"+ButtonID+"Up")
   {
      N=N+1;
      ObjectSetInteger(ChartID(),sparam,OBJPROP_STATE,false);
   }
//---   
   if (id==CHARTEVENT_OBJECT_CLICK && sparam=="sub"+ButtonID+"Down")
   {
      N=N-1;
      ObjectSetInteger(ChartID(),sparam,OBJPROP_STATE,false);
   }
//---
   if (id==CHARTEVENT_OBJECT_CLICK && sparam=="main"+ButtonID)
   {
      N=Nstart;
      ObjectSetInteger(ChartID(),sparam,OBJPROP_STATE,false);
   }   
//---   
   ObjectSetString(ChartID(),"main"+ButtonID,OBJPROP_TEXT,"Min/Max is "+string(N)+" bars");
   
   double Max = iHigh(NULL,timeFrame,iHighest(NULL,timeFrame,MODE_HIGH,N,0)); 
   double Min = iLow(NULL,timeFrame,iLowest(NULL,timeFrame,MODE_LOW,N,0)); 
   ARROW("Max",Time[0],Max,Blue,6);                     
   ARROW("Min",Time[0],Min,Red,6);                     
   TREND("Max1",iTime(NULL,timeFrame,N),Max,Time[0],Max,Blue,0,1);                     
   TREND("Min1",iTime(NULL,timeFrame,N),Min,Time[0],Min,Red,0,1);
} 
//--------------------------------------------------------------------
void ARROW(string name, datetime T1, double P1, color C, int ARROWCODE)
{
   ObjectDelete(name);                     
   ObjectCreate(name,OBJ_ARROW,0,T1,P1,0,0,0,0);                     
   ObjectSet   (name,OBJPROP_ARROWCODE,ARROWCODE);
   ObjectSet   (name,OBJPROP_COLOR, C);
}
//--------------------------------------------------------------------+
void TREND(string name, datetime T1, double P1, datetime T2, double P2, color C, int STYLE, int WIDTH)
{
   ObjectDelete(name);                     
   ObjectCreate(name, OBJ_TREND,0,T1,P1,T2,P2);                     
   ObjectSet   (name, OBJPROP_COLOR, C);   
   ObjectSet   (name, OBJPROP_STYLE, STYLE);
   ObjectSet   (name, OBJPROP_WIDTH, WIDTH);
   ObjectSet   (name, OBJPROP_BACK,  true);
   ObjectSet   (name, OBJPROP_RAY,   false); 
}
//--------------------------------------------------------------------+
int start() { return(0); }

